Unable to retrieve custom fields set as "For all projects" via Projects API
Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: REST API Estimated time: 0.00 hour

Target version: 5.1.0   

Resolution: Fixed Affected version: 5.0.4

Description

Create a custom field for the Issue and check "For all projects".
When retrieving Issue custom fields in the Projects API, those with "For all projects" checked will not be retrieved.

http://example.com/projects.xml?include=issue_custom_fields

<projects total_count="2" offset="0" limit="25" type="array">

  <project>

    <id>1</id>

    <name>a</name>

    <identifier>a</identifier>

    <description/>

    <status>1</status>

    <is_public>true</is_public>

    <inherit_members>false</inherit_members>

    <issue_custom_fields type="array">

      <custom_field id="2" name="Per Projects"/>

    </issue_custom_fields>

    <created_on>2023-06-07T09:45:45Z</created_on>

    <updated_on>2023-06-07T09:45:45Z</updated_on>

  </project>

  <project>

    <id>2</id>

    <name>b</name>

    <identifier>b</identifier>

    <description/>

    <status>1</status>

    <is_public>false</is_public>

    <inherit_members>false</inherit_members>

    <issue_custom_fields type="array"/>

    <created_on>2023-06-07T09:45:57Z</created_on>

    <updated_on>2023-06-07T09:45:57Z</updated_on>

  </project>

</projects>

 I thought it should also be possible to retrieve those specified in "For all projects."

I have confirmed that the following modification will result in the intended behavior.

projects_helper.rb.diff

Related issues:

Related to Redmine - Feature #33301: Add option to include enabled issue cust... Closed

Associated revisions

Revision 22270 - 2023-06-30 11:20 - Go MAEDA

Unable to retrieve custom fields set as "For all projects" via Projects API (#38668).

Patch by Hirokazu Onozato.

2025-05-02 1/2

http://example.com/projects.xml?include=issue_custom_fields
https://www.redmine.org/attachments/30535


History

#1 - 2023-06-21 11:57 - Go MAEDA

- Related to Feature #33301: Add option to include enabled issue custom fields in projects#show API response added

#2 - 2023-06-21 11:59 - Go MAEDA

- Status changed from New to Confirmed

- Target version set to Candidate for next major release

#3 - 2023-06-22 06:34 - Go MAEDA

- Target version changed from Candidate for next major release to 5.1.0

The code below is a test for the suggested fix. Setting the target version to 5.1.0.

diff --git a/test/integration/api_test/projects_test.rb b/test/integration/api_test/projects_test.rb

index f0c1973cb..c32f7679b 100644

--- a/test/integration/api_test/projects_test.rb

+++ b/test/integration/api_test/projects_test.rb

@@ -86,11 +86,16 @@ class Redmine::ApiTest::ProjectsTest < Redmine::ApiTest::Base

   end

   test "GET /projects.xml with include=issue_custom_fields should return custom fields" do

+    IssueCustomField.find(6).update_attribute :is_for_all, true

+    IssueCustomField.find(8).update_attribute :is_for_all, false

     get '/projects.xml?include=issue_custom_fields'

     assert_response :success

     assert_equal 'application/xml', @response.media_type

     assert_select 'issue_custom_fields[type=array] custom_field[name="Project 1 cf"]'

+    # Custom field for all projects

+    assert_select 'issue_custom_fields[type=array] custom_field[id="6"]'

+    assert_select 'issue_custom_fields[type=array] custom_field[id="8"]', 0

   end

   test "GET /projects/:id.xml should return the project" do

#4 - 2023-06-30 11:20 - Go MAEDA

- Subject changed from Custom field set in "For all projects" cannot be retrieved by the projects API to Unable to retrieve custom fields set as "For all

projects" via Projects API

- Status changed from Confirmed to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch. Thank you for your contribution.
